<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
	<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8">
	<TITLE>JFLAP: Moore Machine Examples</TITLE>
	<META NAME="GENERATOR" CONTENT="OpenOffice.org 1.1.5  (Linux)">
	<META NAME="CREATED" CONTENT="20070710;16052500">
	<META NAME="CHANGED" CONTENT="20070710;16124800">
	<!--@author Jinghui Lim-->
</HEAD>
<BODY LANG="en-US" DIR="LTR">
<H1>Moore Machine Examples</H1>
<H2>Contents</H2>
<P><A HREF="mooreMachines.html">Back to Moore Machines</A><BR><A HREF="#ex1">Example
1: NOT</A><BR><A HREF="#ex2">Example 2: Halving a Binary Number</A></P>
<H2><A NAME="ex1"></A>Example 1: NOT</H2>
<P>Let's start with a simple Moore machine that takes an input bit
string <I>b</I> and produces the output NOT(<I>b</I>).</P>
<P>The machine should look like this, and is can be downloaded
through <A HREF="files/mooreNOT.jff">mooreNOT.jff</A>: 
</P>
<P ALIGN=CENTER><IMG SRC="images/mooreNOT.png" NAME="Graphic1" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>A Moore machine that produces NOT(<I>b</I>) 
</P>
<P>As you can see, this machine has three states, with <I>q</I><SUB>0</SUB>
producing no output, <I>q</I><SUB>1</SUB> producing the output &quot;1&quot;,
and <I>q</I><SUB>2</SUB> producing the output &quot;0&quot;. 
</P>
<P>The initial state, <I>q</I><SUB>0</SUB> produces no output as, in
this case, we do not want the machine to produce an output if it is
not given any input. (We adopt the <A HREF="mooreMachines.html#outputConvention">output
convention</A> that the initial state produces output even if there
is no input.) As you can see, if we do not want the initial state to
produce output, we can use a &quot;dummy state,&quot; like <I>q</I><SUB>0</SUB>.
</P>
<P>There are two other states, <I>q</I><SUB>1</SUB> that produces the
output &quot;0&quot;, and <I>q</I><SUB>2</SUB> that produces the
output &quot;1&quot;. Any outgoing transition on the input &quot;0&quot;
goes to <I>q</I><SUB>2</SUB>, so the input bit &quot;0&quot; always
produces the output bit &quot;1&quot;. Similarly, any outgoing
transition on the input &quot;1&quot; goes to <I>q</I><SUB>1</SUB>,
so the input bit &quot;1&quot; always produces the output bit &quot;0&quot;.
</P>
<P>Let's step the machine through the input &quot;101&quot;. 
</P>
<P ALIGN=CENTER><IMG SRC="images/mooreEx1Step0.png" NAME="Graphic2" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>Initial set up 
</P>
<P>The machine is in its initial state, <I>q</I><SUB>0</SUB>. It does
not produce any output because the output assigned to that state is
λ<!--lambda-->, or the empty string. Click <B>Step</B> to process
the next bit of the input. 
</P>
<P ALIGN=CENTER><IMG SRC="images/mooreEx1Step1.png" NAME="Graphic3" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>Step 1 
</P>
<P>Upon processing the first bit of the input, &quot;1&quot;, the
machine takes the transition to <I>q</I><SUB>1</SUB>. At <I>q</I><SUB>1</SUB>,
it produces the output bit &quot;0&quot;, which is the negation of
the input bit. If we examine <I>q</I><SUB>0</SUB>, we can see that it
will always correctly handle the first bit of intput. The state
itself produces no output. If the first bit of input is &quot;1&quot;,
it will take the transition to <I>q</I><SUB>1</SUB>, that will
produce the output of &quot;0&quot;. On the other hand, if the first
bit of input is &quot;0&quot;, it will take the transition to <I>q</I><SUB>2</SUB>,
producing the output of &quot;1&quot;. Click <B>Step</B> to process
the next bit of the input. 
</P>
<P ALIGN=CENTER><IMG SRC="images/mooreEx1Step2.png" NAME="Graphic4" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>Step 2 
</P>
<P>Upon processing the next bit of the input, &quot;0&quot;, the
machine takes the transition to <I>q</I><SUB>2</SUB>. At <I>q</I><SUB>2</SUB>,
it produces the output bit &quot;1&quot;, which is the negation of
the input bit. If we examine all the incoming transitions to <I>q</I><SUB>2</SUB>
we will see that, from any state, the input of &quot;0&quot; will
cause the machine to enter <I>q</I><SUB>2</SUB>. Thus, from any
state, the input bit &quot;0&quot; will create the output of &quot;1&quot;.
Click <B>Step</B> to process the next bit of the input. 
</P>
<P ALIGN=CENTER><IMG SRC="images/mooreEx1Step3.png" NAME="Graphic5" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>Step 3 
</P>
<P>On processing the last bit of the input, &quot;1&quot;, the
machine takes the transition to <I>q</I><SUB>1</SUB>. At <I>q</I><SUB>1</SUB>,
it produces the output bit &quot;0&quot;, which is the negation of
the input bit. Examining all incoming transitions to <I>q</I><SUB>1</SUB>,
we will see that, very much like <I>q</I><SUB>2</SUB>, from any
state, the input of &quot;1&quot; will cause the machine to enter <I>q</I><SUB>1</SUB>.
Therfore, from any state, the input bit of &quot;1&quot; will create
the output of &quot;0&quot;. Thus, we have seen that the machine will
produce the negation of any bit string. 
</P>
<P>We can also test this machine on multiple input strings. 
</P>
<P ALIGN=CENTER><IMG SRC="images/mooreMultipleRun.png" NAME="Graphic6" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>Testing the machine on multiple strings 
</P>
<P>As you can see, it produces NOT(<I>b</I>) in every instance. 
</P>
<H2><A NAME="ex2"></A>Example 2: Halving a Binary Number</H2>
<P>Next, let's discuss a slightly more complex machine that halves a
binary number, truncating any decimal places.  It should be noted
that halving a binary number merely involves dropping the least
significant bit, or shifting the number right by one bit. However, we
will make this a little more complicated by dictating that the
machine will receive input starting from the most significant bit to
the least significant bit, or from left to right. Thus, this would
require the machine to remember the most recent two bits of input. 
</P>
<P>The machine should look something like this, and can be downloaded
through <A HREF="files/mooreHalve.jff">mooreHalve.jff</A>: 
</P>
<P ALIGN=CENTER><IMG SRC="images/mooreHalve.png" NAME="Graphic7" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>A Moore machine that halves binary numbers 
</P>
<P>Let's take a look at the machine. There are four possible
permutations of two consecutive bits, 00, 01, 10, and 11, and each is
represented by a state in the machine. For instance, the state 01
means that the most recent input bit was 1, and the input bit before
that was 0. Each state produces the output equivalent to the
second-most recent input bit, and stores the most recent bit to relay
that information to the next state (where it will become the
second-most recent input bit). 
</P>
<P>Let's step through the input &quot;101&quot;. 
</P>
<P ALIGN=CENTER><IMG SRC="images/mooreEx2Step0.png" NAME="Graphic8" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>Initial set up 
</P>
<P>We chose state 00 as the initial state as it is the only state
that accurately represents the binary number before any bits have
been processed. In other words, adding two 0's as the most significan
bits in a binary number will not change the value of the number.
Similarly, the output of state 00, &quot;0&quot;, added as the most
significant bit of the entire output, will not change its value. 
</P>
<P>The state produces the output of &quot;0&quot;. Click <B>Step</B>
to process the next bit. 
</P>
<P ALIGN=CENTER><IMG SRC="images/mooreEx2Step1.png" NAME="Graphic9" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>First bit, &quot;1&quot;, processed 
</P>
<P>The machine has processed the first bit of input, &quot;1&quot;,
taking transition 1 from state 00 to state 01. State 01 then produces
the output &quot;0&quot;. Although this state, state 01, produces the
same output as the initial state, state 00, it is different because
it remembers that the most recent input bit is &quot;1&quot;. Thus,
it takes different transitions than the initial state for the same
input. 
</P>
<P>Notice that all outgoing transitions from this state, state 01 go
to states that produce an output of &quot;1&quot;. This is equivalent
to the function of shifting the bits right by one, as the machine's
output is the second-most recent bit. Click <B>Step</B> to process
the next bit. 
</P>
<P ALIGN=CENTER><IMG SRC="images/mooreEx2Step2.png" NAME="Graphic10" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>Second bit, &quot;0&quot;, processed 
</P>
<P>The machine processes the next bit of input, &quot;0&quot;, and
takes transition 0 to state 10. State 10 then produces the output
&quot;1&quot;, which corresponds to the previous input bit, &quot;1&quot;.
This state now remembers that the most recent input bit was &quot;0&quot;,
and all outgoing transitions are to states which have the output &quot;0&quot;.
Click <B>Step</B> to process the next bit. 
</P>
<P ALIGN=CENTER><IMG SRC="images/mooreEx2Step3.png" NAME="Graphic11" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>Last bit, &quot;1&quot;, processed 
</P>
<P>The machine processes the last bit of input, &quot;1&quot;, and
takes transition 1 to state 01. It produces the output &quot;0&quot;,
completing the output. Although the most recent, and last, input bit
was &quot;1&quot;, this is ignored, effectively shifting all the bits
to the right by one. This concludes the machines process of dividing
a binary number by two. 
</P>
<P>Let's try our machine out on different numbers. 
</P>
<P ALIGN=CENTER><IMG SRC="images/mooreEx2MultipleRun.png" NAME="Graphic12" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>Running the machine on different numbers 
</P>
<P>As you can see, the machine produces the correct results in each
instance. You might notice that in every instance, the output starts
with &quot;00&quot;, which is unnecessarly, even if it does not
change the number. This is because the machine starts in state 00,
which produces the output &quot;0&quot; even if there is no input. We
could have avoided the this unnecessary &quot;0&quot; by adding a
dummy initial state as we did in the <A HREF="#ex1">previous example</A>.
</P>
<P>The second &quot;0&quot; is due to the fact that all the outgoing
transitions from state 00, lead to states that have the output &quot;0&quot;.
Regardless of the first bit of the input, the first bit of output is
&quot;0&quot; because the number is divided by two, that would shift
all bits to the right by one. This &quot;0&quot; is also necessary
for single-bit numbers such as 0 and 1.</P>
</BODY>
</HTML>
